package com.jcg.objects;

/**
 * @author #hashtagmercury
 */
public class CreateObjectExample {

    {
        System.out.println("Instance initializer 1");
    }
    
    static {
        System.out.println("Static initializer 1");
    }

    static {
        System.out.println("Static initializer 2");
    }
    
    public CreateObjectExample(){
        System.out.println("no-arg Constructor");
    }
    
    public CreateObjectExample(boolean status){
        System.out.println("boolean-arg Constructor");
    }
    
    public static void main(String[] args){
        //Object creation - using no-arg constructor
        CreateObjectExample obj1 = new CreateObjectExample();
        
        //Object creation - using boolean-arg constructor
        CreateObjectExample obj2 = new CreateObjectExample(true);
        
        //calling instance method
        obj1.print();
        
        //calling static method using classname
        CreateObjectExample.print1();
        
        //calling static method using object reference
        obj2.print1();
    }
    //instanceinitiliser
    {
        System.out.println("Instance initializer 2");
    }
    
    public void print(){
        System.out.println("instance method: print method of the object");
    }
    
    public static void print1(){
        System.out.println("static method: print method of the class");
    }
    
    static {
        System.out.println("static initializer 3");
    }
    
    protected void finalize() throws Throwable
    {
        super.finalize();
        System.out.println("finalizer");
    }
}

